﻿using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace WebApplication.model
{
    public class personOA
    {
        /// <summary>
        /// OA审批
        /// </summary>
        public class Person
        {
            /// <summary>
            /// 单据类型
            /// </summary>
            public string F0000015 { get; set; }
            /// <summary>
            /// 标题
            /// </summary>
            public string F0000001 { get; set; }
            /// <summary>
            /// 审批单号
            /// </summary>
            public string F0000004 { get; set; }
            /// <summary>
            /// 发起人
            /// </summary>
            public string F0000006 { get; set; }
            /// <summary>
            /// 开始时间
            /// </summary>
            public string F0000007 { get; set; }
            /// <summary>
            /// 结束时间
            /// </summary>
            public string F0000002 { get; set; }
            /// <summary>
            /// 时长
            /// </summary>
            public string F0000009 { get; set; }
            /// <summary>
            /// 事由
            /// </summary>
            public string F0000011 { get; set; }
            /// <summary>
            /// 附件
            /// </summary>
            public string F0000005 { get; set; }
            /// <summary>
            /// 说明
            /// </summary>
            public string F0000013 { get; set; }
            
        }


        public Person Roleioat(string process,string DocumentType)
        {
            JObject array = JsonConvert.DeserializeObject<JObject>(process);
            Person person = new Person()
            {
                F0000001 = string.IsNullOrEmpty(array["result"]["title"].ToString())?"": array["result"]["title"].ToString(),
                F0000002 = string.IsNullOrEmpty(rolename(array["result"].ToString(), "结束时间"))?"": rolename(array["result"].ToString(), "结束时间"),
                F0000004 = string.IsNullOrEmpty(array["result"]["businessId"].ToString())?"": array["result"]["businessId"].ToString(),
                F0000005 = string.IsNullOrEmpty(rolename(array["result"].ToString(), "附件"))?"": rolename(array["result"].ToString(), "附件"),
                F0000006 = string.IsNullOrEmpty(rolename(array["result"].ToString(), "发起人"))?"": rolename(array["result"].ToString(), "发起人"),
                F0000007 = string.IsNullOrEmpty(rolename(array["result"].ToString(), "开始时间"))?"": rolename(array["result"].ToString(), "开始时间"),
                F0000009 = string.IsNullOrEmpty(rolename(array["result"].ToString(), "时长"))?"": rolename(array["result"].ToString(), "时长"),
                F0000011 = string.IsNullOrEmpty(rolename(array["result"].ToString(), "事由"))?"": rolename(array["result"].ToString(), "事由"),
                F0000013 = string.IsNullOrEmpty(rolename(array["result"].ToString(), "说明"))?"": rolename(array["result"].ToString(), "说明"),
                F0000015 = DocumentType
            };
            return person;
        }

        /// <summary>
        /// 查询Json字段
        /// </summary>
        /// <param name="json">jsons数据</param>
        /// <param name="name">查询字段名称</param>
        /// <returns></returns>
        public string rolename(string json,string name)
        {
            //JArray array = JArray.Parse(json);
            JObject array = JsonConvert.DeserializeObject<JObject>(json);
            foreach (JObject item in array["formComponentValues"][0])
            {
                if (name == item["name"].ToString())
                {
                    return item["value"].ToString();
                }
            }
            return "";
        }
    }
}
